### Hierarchy

- IGameNode
  - IRule

### Implemented by

- SimpleRule
- SimpleRuleGroup
- SimpleRuleLoop

## Index

### Properties

- __coverageCount
- __source
- addCellsToEmptyRules
- clearCaches
- evaluate
- getChildRules
- hasMatches
- hasRigid
- isLate
- timesRan
- totalTimeMs

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- toKey
- toSourceString
- toString

## Properties

### __coverageCount

__coverageCount: Optional<number>

Inherited from IGameNode.__coverageCount

- Defined in models/game.ts:14

### __source

__source: object

Inherited from IGameNode.__source

- Defined in models/game.ts:13

#### Type declaration

- ##### code: string

- ##### sourceOffset: number

### addCellsToEmptyRules

addCellsToEmptyRules: function

- Defined in models/rule.ts:49

#### Type declaration

- - (cells: Iterable<Cell>): void

  - #### Parameters

    - ##### cells: Iterable<Cell>

    #### Returns void

### clearCaches

clearCaches: function

- Defined in models/rule.ts:48

#### Type declaration

- - (): void

  - #### Returns void

### evaluate

evaluate: function

- Defined in models/rule.ts:44

#### Type declaration

- - (level: Level, onlyEvaluateFirstMatch: boolean): IMutation[]

  - #### Parameters

    - ##### level: Level

    - ##### onlyEvaluateFirstMatch: boolean

    #### Returns IMutation[]

### getChildRules

getChildRules: function

- Defined in models/rule.ts:45

#### Type declaration

- - (): IRule[]

  - #### Returns IRule[]

### hasMatches

hasMatches: function

- Defined in models/rule.ts:43

#### Type declaration

- - (level: Level): boolean

  - #### Parameters

    - ##### level: Level

    #### Returns boolean

### hasRigid

hasRigid: function

- Defined in models/rule.ts:47

#### Type declaration

- - (): boolean

  - #### Returns boolean

### isLate

isLate: function

- Defined in models/rule.ts:46

#### Type declaration

- - (): boolean

  - #### Returns boolean

### Optional timesRan

timesRan: undefined | number

- Defined in models/rule.ts:52

### Optional totalTimeMs

totalTimeMs: undefined | number

- Defined in models/rule.ts:51

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Inherited from IGameNode.__getLineAndColumnRange

  - Defined in models/game.ts:16

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Inherited from IGameNode.__getSourceLineAndColumn

  - Defined in models/game.ts:15

  #### Returns object

  - ##### colNum: number

  - ##### lineNum: number

### toKey

- toKey(): string

- - Defined in models/rule.ts:53

  #### Returns string

### toSourceString

- toSourceString(): string

- Inherited from IGameNode.toSourceString

  - Defined in models/game.ts:18

  #### Returns string

### toString

- toString(): string

- Inherited from IGameNode.toString

  - Defined in models/game.ts:17

  #### Returns string

Generated using TypeDoc